# -*- mode: ruby -*-
# vi: set ft=ruby :

# All Vagrant configuration is done below. The "2" in Vagrant.configure
# configures the configuration version (we support older styles for
# backwards compatibility). Please don't change it unless you know what
# you're doing.

proxy_ip = '192.168.33.10'
proxy_name = 'proxy'

server_ip = '192.168.33.11'
server_name = 'server'

Vagrant.configure("2") do |config|
  # The most common configuration options are documented and commented below.
  # For a complete reference, please see the online documentation at
  # https://docs.vagrantup.com.

  # Every Vagrant development environment requires a box. You can search for
  # boxes at https://vagrantcloud.com/search.
  config.vm.box = "debian/buster64"
  config.vm.box_check_update = true


  # The url from where the 'config.vm.box' box will be fetched if it
  # doesn't already exist on the user's system.
  # config.vm.box_url = "https://ap.vagrantup.com/debian/boxes/buster64"

  # Create a forwarded port mapping which allows access to a specific port
  # within the machine from a port on the host machine. In the example below,
  # accessing "localhost:8080" will access port 80 on the guest machine.
  # NOTE: This will enable public access to the opened port
  # config.vm.network "forwarded_port", guest: 80, host: 8080

  # Create a forwarded port mapping which allows access to a specific port
  # within the machine from a port on the host machine and only allow access
  # via 127.0.0.1 to disable public access
  # config.vm.network "forwarded_port", guest: 80, host: 8080, host_ip: "127.0.0.1"

  # Create a private network, which allows host-only access to the machine
  # using a specific IP.


  # Configuration du host manager
  config.hostmanager.enabled = true
  config.hostmanager.manage_host = true

  # Setup de l'ip par rapport aux paramètres globaux
  # The pluging vagrant-hostmager sould be installed :
  # vagrant plugin install vagrant-hostmanager

  config.vm.define "proxy" do |proxy|
    proxy.vm.hostname = proxy_name + '.dev'
    proxy.vm.network "private_network", ip: proxy_ip
    proxy.hostmanager.aliases = [ "www." + proxy_name + ".dev" ]

    proxy.vm.provider "virtualbox" do |v|
            v.name = "proxy"
            v.memory = 2048
            v.cpus = 2
            v.linked_clone = true
            v.gui = false
        end
  end

  config.vm.define "server" do |server|
    server.vm.hostname = server_name + '.dev'
    server.vm.network "private_network", ip: server_ip
    server.hostmanager.aliases = [ "www." + server_name + ".dev" ]

    server.vm.provider "virtualbox" do |v|
            v.name = "server"
            v.memory = 2048
            v.cpus = 2
            v.linked_clone = true
            v.gui = false
        end
  end


  config.vm.provision :hostmanager

  # Create a public network, which generally matched to bridged network.
  # Bridged networks make the machine appear as another physical device on
  # your network.
  # config.vm.network "public_network"

  # Share an additional folder to the guest VM. The first argument is
  # the path on the host to the actual folder. The second argument is
  # the path on the guest to mount the folder. And the optional third
  # argument is a set of non-required options.
  # config.vm.synced_folder "../data", "/vagrant_data"

  # Provider-specific configuration so you can fine-tune various
  # backing providers for Vagrant. These expose provider-specific options.
  # Example for VirtualBox:
  #
  # config.vm.provider "virtualbox" do |vb|
  #   # Display the VirtualBox GUI when booting the machine
  #   vb.gui = true
  #
  #   # Customize the amount of memory on the VM:
  #   vb.memory = "1024"
  # end
  #
  # View the documentation for the provider you are using for more
  # information on available options.

  # Enable provisioning with a shell script. Additional provisioners such as
  # Ansible, Chef, Docker, Puppet and Salt are also available. Please see the
  # documentation for more information about their specific syntax and use.
  # config.vm.provision "shell", inline: <<-SHELL
  #   apt-get update
  #   apt-get install -y apache2
  # SHELL
end
